"
 COPYRIGHT (c) 1994 by Claus Gittinger
	      All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"

SelfNode subclass:#SuperNode
       instanceVariableNames:'class isHere'
       classVariableNames:''
       poolDictionaries:''
       category:'System-Compiler-Support'
!

SuperNode comment:'
COPYRIGHT (c) 1994 by Claus Gittinger
	     All Rights Reserved

$Header: /cvs/stx/stx/libcomp/SuperNode.st,v 1.4 1994-11-17 14:22:45 claus Exp $
'!

!SuperNode class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 1994 by Claus Gittinger
	      All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
!

version
"
$Header: /cvs/stx/stx/libcomp/SuperNode.st,v 1.4 1994-11-17 14:22:45 claus Exp $
"
!

documentation
"
    node for parse-trees, representing super
"
! !

!SuperNode class methodsFor:'instance creation'!

value:val inClass:cls 
    ^ (self basicNew) value:val inClass:cls here:false
!

value:val inClass:cls here:isHere
    ^ (self basicNew) value:val inClass:cls here:isHere
! !

!SuperNode methodsFor:'accessing'!

value:val inClass:cls here:h
    type := #Super.
    value := val.
    class := cls.
    isHere := h
!

definingClass
    ^ class
! !

!SuperNode methodsFor:'queries'!

isSuper
    "return true, if this is a super-node"

    ^ true
!

isHere
    ^ isHere
! !

!SuperNode methodsFor:'printing'!

printOn:aStream indent:i
    isHere ifTrue:[
	aStream nextPutAll:'here'
    ] ifFalse:[
	aStream nextPutAll:'super'
    ]
! !
